# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetOncallIntegrationResult',
    'AwaitableGetOncallIntegrationResult',
    'get_oncall_integration',
    'get_oncall_integration_output',
]

warnings.warn("""grafana.index/getoncallintegration.getOncallIntegration has been deprecated in favor of grafana.oncall/getintegration.getIntegration""", DeprecationWarning)

@pulumi.output_type
class GetOncallIntegrationResult:
    """
    A collection of values returned by getOncallIntegration.
    """
    def __init__(__self__, id=None, name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The integration ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The integration name.
        """
        return pulumi.get(self, "name")


class AwaitableGetOncallIntegrationResult(GetOncallIntegrationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOncallIntegrationResult(
            id=self.id,
            name=self.name)


def get_oncall_integration(id: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOncallIntegrationResult:
    """
    * [HTTP API](https://grafana.com/docs/oncall/latest/oncall-api-reference/integrations/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_grafana as grafana

    example_integration = grafana.onCall.get_integration(id="CEXAMPLEID123")
    ```


    :param str id: The integration ID.
    """
    pulumi.log.warn("""get_oncall_integration is deprecated: grafana.index/getoncallintegration.getOncallIntegration has been deprecated in favor of grafana.oncall/getintegration.getIntegration""")
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('grafana:index/getOncallIntegration:getOncallIntegration', __args__, opts=opts, typ=GetOncallIntegrationResult).value

    return AwaitableGetOncallIntegrationResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'))
def get_oncall_integration_output(id: Optional[pulumi.Input[str]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOncallIntegrationResult]:
    """
    * [HTTP API](https://grafana.com/docs/oncall/latest/oncall-api-reference/integrations/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_grafana as grafana

    example_integration = grafana.onCall.get_integration(id="CEXAMPLEID123")
    ```


    :param str id: The integration ID.
    """
    pulumi.log.warn("""get_oncall_integration is deprecated: grafana.index/getoncallintegration.getOncallIntegration has been deprecated in favor of grafana.oncall/getintegration.getIntegration""")
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('grafana:index/getOncallIntegration:getOncallIntegration', __args__, opts=opts, typ=GetOncallIntegrationResult)
    return __ret__.apply(lambda __response__: GetOncallIntegrationResult(
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name')))
